%     NITOOL     NATURE INSPIRED TOOLBOX

% ======================================================
%   PROGRAM AIM :
%         NATURE INSPIRED TOOLBOX  SUPPORT FILE
% ======================================================
%   USAGE :
%         1. nitgui(action)
% ==============================================
%   SATVIR SINGH SIDHU, ARUN KHOSLA, JASBIR SINGH SAINI
%   JULY 2009
%   COPYRIGHT RESERVED
% ==============================================

function nitgui(action, oldName, newName)

if strcmp(action,'#initialize')
    % Create the main menubar items File Edit View common to every editor.
    % Create the File main menu item, and its submenus, then call createmenu to create
    % the Edit, View and Options mainmenu items.
    figNit = watchon;
    oldnit=get(figNit,'UserData');
    nit=oldnit{1};
    figNit=findobj(0, 'Type', 'Figure', 'Name', ['NIT Editor: ' nit.Name '.' nit.Type]);

    % Main menu bar item File -------------------------------------------------
    fileHndl=uimenu(figNit,'Label','File','Accelerator','F');
    N = uimenu('Parent', fileHndl,...
        'Label', 'New',...
        'Separator','off');
    uimenu('Parent', N,...
        'Label', 'PSO',...
        'Callback', 'nitgui #filePSO');
    uimenu('Parent', N,...
        'Label', 'GA',...
        'Callback', 'nitgui #fileGA');
    uimenu('Parent', N,...
        'Label', 'ACO',...
        'Callback', 'nitgui #fileACO');
    uimenu('Parent', N,...
        'Label', 'BBO',...
        'Callback', 'nitgui #fileBBO');
    O = uimenu('Parent', fileHndl,...
        'Label', 'Open',...
        'Separator','off',...
        'Accelerator', 'O',...
        'Tag', 'fileopen',...
        'Callback', 'nitgui #fileopen');
    S = uimenu('Parent', fileHndl,...
        'Label', 'Save As',...
        'Separator','on',...
        'Accelerator', 'S',...
        'Tag', 'filesave',...
        'Callback', 'nitgui #filesave');
    W = uimenu('Parent', fileHndl,...
        'Label', 'Export to WS...',...
        'Separator','off',...
        'Accelerator', 'W',...
        'Tag', 'fileexport',...
        'Callback', 'nitgui #fileexport');
    X = uimenu('Parent', fileHndl,...
        'Label', 'Close',...
        'Separator','on',...
        'Accelerator', 'X',...
        'Tag', 'fileclose',...
        'Callback', 'nitgui #fileclose');

    % Main menu bar item Edit---------------------------------------------------
    Handles.optionHndl=uimenu(figNit, 'Label', 'Option', 'Accelerator','O');
    R = uimenu('Parent', Handles.optionHndl,...
        'Label', 'RUN',...
        'Separator','on',...
        'Accelerator', 'R',...
        'Tag', 'runEvo',...
        'Callback', 'nitgui #run');
    I = uimenu('Parent', Handles.optionHndl,...
        'Label', 'Import...',...
        'Separator','off',...
        'Accelerator', 'I',...
        'Tag', 'optionimport',...
        'Callback', 'nitgui #optionimport');
    P = uimenu('Parent', Handles.optionHndl,...
        'Label', 'Plot(s)',...
        'Separator','on',...
        'Accelerator', 'P',...
        'Tag', 'optionplot');
    uimenu('Parent', P,...
        'Label', 'Best Fitness',...
        'Separator','off',...
        'Tag', 'plotbest',...
        'Callback', 'nitgui #plotbest');
    uimenu('Parent', P,...
        'Label', 'Average Fitness',...
        'Separator','off',...
        'Tag', 'plotbest',...
        'Callback', 'nitgui #plotavg');

    % Main menu bar item View------------------------------------------------------
    Handles.helpHndl=uimenu(figNit, 'Label', 'Help', 'Accelerator','H');
    PSO = uimenu('Parent', Handles.helpHndl,...
        'Label', 'PSO',...
        'Separator','off',...
        'Tag', 'helppso',...
        'Callback', 'nitgui #helppso');
    NIT = uimenu('Parent', Handles.helpHndl,...
        'Label', 'About NIT',...
        'Separator','on',...
        'Tag', 'helpnit',...
        'Callback', 'nitgui #helpnit');
    Handles.viewHndl=0;
%     Handles.viewHndl=uimenu('Parent', figNit,'Label', 'View', 'Tag', 'viewmenu');

    % Populate the fuzzy editor specific submenu items
%     nitmenu(figNit, tag, Handles);

elseif strcmp(action,'#filePSO')
    %   NEW PSO FILE
    %   ===================================
    newNit=newnit('Untitled', 'PSO');
    nitool(newNit);

elseif strcmp(action,'#fileGA')
    %   NEW GA FILE
    %   ===================================
    newNit=newnit('Untitled', 'GA');
    nitool(newNit);
    
elseif strcmp(action,'#fileACO')
    %   NEW GA FILE
    %   ===================================
    newNit=newnit('Untitled', 'ACO');
    nitool(newNit);

elseif strcmp(action,'#fileBBO')
    %   NEW GA FILE
    %   ===================================
    newNit=newnit('Untitled', 'BBO');
    nitool(newNit);

elseif strcmp(action,'#fileopen')
    %   OPEN EXISTING FILE
    %   ===================================
    [fileName, pathName] = uigetfile( ...
        {'*.PSO; *.GA; *.ACO; *.ACO', 'NIT Files (*.PSO,*.GA,*.ACO,*.BBO)';
        '*.PSO', 'Particle Swarm Optimization files (*.PSO)'; ...
        '*.GA','Genetic Algorithms file (*.GA)'; ...
        '*.ACO','Ant Colony Optimization files (*.ACO)'; ...
        '*.BBO','Biogeoraphical Based Optimization (*.BBO)'; ...
        '*.*',  'All Files (*.*)'}, ...
        'Open an NIT File');
    ExstNit = rdnit(fileName);
    nitool(ExstNit);

elseif strcmp(action,'#filesave')
    %   SAVE AS FILE ON DISK
    %   ===================================
    fig =watchon;
    thisnit{1} = get(fig, 'UserData');
    nit = thisnit{1};
    figNit = findobj(0, 'Type', 'Figure', 'Name', ['NIT Editor: ' nit.Name '.' nit.Type]);
    figPlot = findobj(0, 'Type', 'Figure', 'Name', ['NIT Plots: ' nit.Name '.' nit.Type]);
    nit = wrnit(nit);
    set(figNit, 'Name', ['NIT Editor: ' nit.Name '.' nit.Type], 'UserData', nit);
    set(figPlot, 'Name', ['NIT Plots: ' nit.Name '.' nit.Type], 'UserData', nit);
    set(fig, 'UserData', nit);
    watchoff(fig);
    
elseif strcmp(action,'#fileexport')
    %   EXPORT TO WORKSPACE
    %   ===================================
    figNit = watchon;
    nit = get(figNit, 'UserData');
    [p name x v] = fileparts(nit.Name);
    assignin('base', name, nit);
    watchoff(figNit);

elseif strcmp(action,'#fileclose')
    %   CLOSE EXISTING SYSTEM
    %====================================
    %     delete(gcf)

    figNit = gcf;
    allnit = get(figNit,'UserData');
    nit = allnit;

    nameList=[ ...
        'NIT Editor      '
        'NIT Plots       '
        'About NI Toolbox'];
    NameExt = [nit.Name '.' nit.Type];
    visFigList = [];
    invisFigList = [];
    % See who's left onscreen
    for count = 1:size(nameList, 1)
        WinName = deblank(nameList(count,:));

        visFigList = [visFigList findobj(0, 'Type', 'Figure',...
            'Name', [WinName ': ' NameExt], 'Visible', 'on')'];
        invisFigList = [invisFigList findobj(0, 'Type', 'Figure',...
            'Name', [WinName ': ' NameExt], 'Visible', 'off')'];
    end

    if length(visFigList)==1 | length(visFigList)==2,
        % This is the last visible relative. Closing this will mean losing data.
        nittemp{1}=nit; %make a cell
        svdlg(nittemp, [visFigList invisFigList]);
    else
        set(figNit, 'Visible', 'off');
    end

elseif strcmp(action,'#optionimport')
    %   IMPORT SYSTEM OPTIONS
    %====================================
    'import options'

elseif strcmp(action,'#strfile')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    StrFile = get(CObj, 'String');
    nit.String.File= StrFile;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#strfileBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    StrFile = get(CObj, 'String');
    nit.String.File= StrFile;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#strsheet')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    StrSheet = get(CObj, 'String');
    nit.String.Sheet = StrSheet;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#strsheetBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    StrSheet = get(CObj, 'String');
    nit.String.Sheet = StrSheet;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#strrange')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    StrRange = get(CObj, 'String');
    nit.String.Range = StrRange;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#strrangeBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    StrRange = get(CObj, 'String');
    nit.String.Range = StrRange;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#chkfile')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    ChkFile = get(CObj, 'String');
    nit.Checks.File = ChkFile;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#chksheet')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    ChkSheet = get(CObj, 'String');
    nit.Checks.Sheet = ChkSheet;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#chkrange')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    ChkRange = get(CObj, 'String');
    nit.Checks.Range = ChkRange;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#chkfileBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    ChkFile = get(CObj, 'String');
    nit.Checks.File = ChkFile;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#chksheetBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    ChkSheet = get(CObj, 'String');
    nit.Checks.Sheet = ChkSheet;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#chkrangeBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    ChkRange = get(CObj, 'String');
    nit.Checks.Range = ChkRange;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#vfunBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    VFunStr = get(CObj, 'String');
    nit.String.VFunction = VFunStr;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#eliteBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Migration.Elite = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#ImmRateBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Migration.ImmRate = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#EmiRateBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Migration.EmiRate = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#ImmBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    migstr = strvcat('Uniform Linear', 'Exponential',...
        'Sine(-Pi/2, Pi/2)','Tangent(-Pi, Pi)', 'Step at N/2');
    nit.Migration.ImmCurve = migstr(get(CObj, 'Value'), :);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#EmiBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    migstr = strvcat('Uniform Linear', 'Exponential',...
        'Sine(-Pi/2, Pi/2)','Tangent(-Pi, Pi)', 'Step at N/2');
    nit.Migration.EmiCurve = migstr(get(CObj, 'Value'), :);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#trgfileBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Objective.File = get(CObj, 'String');
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#trgsheetBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Objective.Sheet = get(CObj, 'String');
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#trgrangeBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Objective.Range = get(CObj, 'String');
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#FitFunBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Objective.Function = get(CObj, 'String');
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#Habitats')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Parameter.Habitats = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);
    
elseif strcmp(action,'#migOprBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    migopr = strvcat('Standard', 'Blended');
    nit.Parameter.MigOperator = migopr(get(CObj, 'Value'), :);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#Migration')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Parameter.Migration = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#mutOprBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    migopr = strvcat('Standard', 'Flat', 'Triangular');
    nit.Parameter.MutOperator = migopr(get(CObj, 'Value'), :);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#Mutation')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Parameter.Mutation = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);
    
elseif strcmp(action,'#PoolBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    migopr = strvcat('Old+New', 'New Only');
    nit.Parameter.Pool = migopr(get(CObj, 'Value'), :);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#refuseBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObjPop = gcbo;
    ObjEdt = findobj(figNit, 'Style', 'Edit', 'Tag', 'refThBBO');
    migopr = strvcat('Enable', 'Disable');
    nit.Parameter.Refusal = migopr(get(CObjPop, 'Value'), :);
    if get(CObjPop, 'Value') == 1, set(ObjEdt, 'Enable', 'On');
    else, set(ObjEdt, 'Enable', 'Off'); end
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#refusThBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Parameter.Threshold = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#smFitBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Terminate.NoChange = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#objvalBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Terminate.Goal = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);
    
elseif strcmp(action,'#maxitrBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Terminate.MaxIterations = str2num(get(CObj, 'String'));
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#GplotBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Plot.Global = get(CObj, 'Value');
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#AplotBBO')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    nit.Plot.Average = get(CObj, 'Value');
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#psize')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    PSizeStr = get(CObj, 'String');
    nit.Swarm.PSize = str2num(PSizeStr);
    set(figNit, 'UserData', nit);
    watchoff(figNit);
    
elseif strcmp(action,'#vfun')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    VFunStr = get(CObj, 'String');
    nit.Swarm.VFunction = VFunStr;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#psomodel')
    %   IMPORT SYSTEM OPTIONS
    %====================================
    figNit = watchon;
    nit = get(figNit, 'UserData');
    psoM = findobj(figNit, 'Tag', 'PSOModel');
    nsize = findobj(figNit, 'Tag', 'NSize');
    topo = findobj(figNit, 'Tag', 'Topo');
    txtc2 = findobj(figNit, 'Tag', 'TxtC2');
    parc2 = findobj(figNit, 'Tag', 'ParC2');
    txtc3 = findobj(figNit, 'Tag', 'TxtC3');
    parc3 = findobj(figNit, 'Tag', 'ParC3');
    PltL = findobj(figNit, 'Tag', 'plotLBest'); 
    if get(psoM, 'Value')==1
        nit.Swarm.Model = 'GBest';
        set(nsize, 'Enable', 'Off');
        set(topo, 'Enable', 'Off');
        set(txtc2, 'Enable', 'On');
        set(parc2, 'Enable', 'On');
        set(txtc3, 'Enable', 'Off');
        set(parc3, 'Enable', 'Off');
        set(PltL, 'Enable', 'Off');
    elseif get(psoM, 'Value')==2
        nit.Swarm.Model = 'LBest';
        set(nsize, 'Enable', 'On');
        set(topo, 'Enable', 'On');
        set(txtc2, 'Enable', 'Off');
        set(parc2, 'Enable', 'Off');
        set(txtc3, 'Enable', 'On');
        set(parc3, 'Enable', 'On');
        set(PltL, 'Enable', 'On');
    elseif get(psoM, 'Value')==3
        nit.Swarm.Model = 'HBest';
        set(nsize, 'Enable', 'On');
        set(topo, 'Enable', 'On');
        set(txtc2, 'Enable', 'On');
        set(parc2, 'Enable', 'On');
        set(txtc3, 'Enable', 'On');
        set(parc3, 'Enable', 'On');
        set(PltL, 'Enable', 'On');
    end
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#nsize')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    NSizeVal = get(CObj, 'Value');
    if NSizeVal == 1
        nit.Swarm.NSize = 1;
    elseif NSizeVal == 2
        nit.Swarm.NSize = 2;
    elseif NSizeVal == 3
        nit.Swarm.NSize = 3;
    end
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#topology')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    TopoVal = get(CObj, 'Value');
    if TopoVal == 1
        nit.Swarm.Topology = 'Ring';
    elseif TopoVal == 2
        nit.Swarm.Topology = 'Linear';
    elseif TopoVal == 3
        nit.Swarm.Topology = 'Wheel';
    end
    set(figNit, 'UserData', nit);
    watchoff(figNit);
    
elseif strcmp(action,'#trgfile')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    TrgFile = get(CObj, 'String');
    nit.Objective.File = TrgFile;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#trgsheet')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    TrgSheet = get(CObj, 'String');
    nit.Objective.Sheet = TrgSheet;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#trgrange')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    TrgRange = get(CObj, 'String');
    nit.Objective.Range = TrgRange;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#FitFun')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    FuncStr = get(CObj, 'String');
    nit.Objective.Function = FuncStr;
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#C1')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    C1 = get(CObj, 'String');
    nit.Parameter.C1 = str2num(C1);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#C2')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    C2 = get(CObj, 'String');
    nit.Parameter.C2 = str2num(C2);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#C3')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    C3 = get(CObj, 'String');
    nit.Parameter.C3 = str2num(C3);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#velo')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    Vel = get(CObj, 'String');
    nit.Parameter.MaxVelocity = str2num(Vel);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#chi')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    Chi = get(CObj, 'String');
    nit.Parameter.Chi = str2num(Chi);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#WtOption')
    %   IMPORT SYSTEM OPTIONS
    %====================================
    figNit = watchon;
    nit = get(figNit, 'UserData');
    WtOp = findobj(figNit, 'Tag', 'WtOpt');
    EndW = findobj(figNit, 'Tag', 'NdWt');
    TxtNdW = findobj(figNit, 'Tag', 'TxtNdWt');
    if get(WtOp, 'Value')==2
        set(EndW, 'Enable', 'On');
        set(TxtNdW, 'Enable', 'On');
        nit.Parameter.WeightOption = 'Variable';
    else
        set(EndW, 'Enable', 'Off');
        set(TxtNdW, 'Enable', 'Off');
        nit.Parameter.WeightOption = 'Fixed';
    end
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#startwt')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    StartWt = get(CObj, 'String');
    nit.Parameter.StartWeight = str2num(StartWt);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#endwt')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    EndWt = get(CObj, 'String');
    nit.Parameter.EndWeight = str2num(EndWt);
    set(figNit, 'UserData', nit);
    watchoff(figNit);


elseif strcmp(action,'#nochange')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    NCItr = get(CObj, 'String');
    nit.Terminate.NoChange = str2num(NCItr);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#objval')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    ObjVal = get(CObj, 'String');
    nit.Terminate.Goal = str2num(ObjVal);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#maxitr')
    figNit = watchon;
    nit = get(figNit, 'UserData');
    CObj = gcbo;
    MxItr = get(CObj, 'String');
    nit.Terminate.MaxIterations = str2num(MxItr);
    set(figNit, 'UserData', nit);
    watchoff(figNit);

elseif strcmp(action,'#nitplots')
    %   NIT PLOT OPTIONS
    %====================================
    figNit = findobj(0, 'Type', 'Figure', 'Tag', 'nitFig');
    nit = get(figNit, 'UserData');
    NITpltHdl = ['NIT Plots: ' nit.Name '.' nit.Type];
    GHdl = findobj(figNit, 'Tag', 'plotGBest');
    G = get(GHdl, 'Value');
    AHdl = findobj(figNit, 'Tag', 'plotAvg');
    A = get(AHdl, 'Value');
    LHdl = findobj(figNit, 'Tag', 'plotLBest');
    L = get(LHdl, 'Value');
    Val = [G A L];
    figPlot = findobj(0, 'Type', 'Figure', 'Name', NITpltHdl, 'Tag', 'nitPlot')
    
    Gline = findobj(figPlot, 'Type', 'Line', 'Color', 'r');
    if G == 1, set(Gline, 'Visible', 'On'); nit.Plot.Global = 1;
    else set(Gline, 'Visible', 'Off'); nit.Plot.Global = 0; end
    
    Aline = findobj(figPlot, 'Type', 'Line', 'Color', 'b');
    if A == 1, set(Aline, 'Visible', 'On'); nit.Plot.Average = 1;
    else set(Aline, 'Visible', 'Off'); nit.Plot.Average = 0; end
    
    if  sum(Val)~=0, set(figPlot, 'Visible', 'On');
    else set(figPlot, 'Visible', 'Off'); end
    set(figNit, 'UserData', nit);
    
elseif strcmp(action,'#plotavg')
    %   IMPORT SYSTEM OPTIONS
    %====================================
    'plot average fitness'
    'enable / disable'

elseif strcmp(action,'#helppso')
    %   IMPORT SYSTEM OPTIONS
    %====================================
    'help PSO'
    
elseif strcmp(action,'#helpnit')
    %   IMPORT SYSTEM OPTIONS
    %====================================
    figNit = watchon;
    nit = get(figNit, 'UserData');
    aboutNIT(nit);
    watchoff(figNit);
    
elseif strcmp(action,'#lic')
    %   IMPORT SYSTEM OPTIONS
    %====================================
    winopen('license.txt');

elseif strcmp(action,'#run')
% close all
    %   RUN EVOLUTION WHEN [RUN] BUTTON PRESSED
    %====================================
    figNit = watchon;
    nit = get(figNit, 'UserData');
    watchoff(figNit);
    runnit(nit);
    % END OF NITGUI
end
